Knowledge Base ISC Main Website Ask a Question/Contact ISC
CVE-2009-0025: EVP_VerifyFinal() and DSA_do_verify() return checks
Author: Cathy Almond Reference Number: AA-00925 Views: 5231 Created: 2013-05-23 17:03 Last Updated: 2013-05-23 17:03 0 Rating/ Voters

Return values from OpenSSL library functions EVP_VerifyFinal() and DSA_do_verify() were not checked properly

CVE: 
CVE-2009-0025  
Posting date: 
05 Jan 2009
Program Impacted: 
BIND
Versions affected: 
9.0 (all versions), 9.1 (all versions), 9.2 (all versions), 9.3.0, 9.3.1, 9.3.2, 9.3.3, 9.3.4, 9.3.5, 9.3.6, 9.4.0, 9.4.1, 9.4.2, 9.4.3, 9.5.0, 9.5.1, 9.6.0
Severity: 
Low
Exploitable: 
Remotely

Description:

Note: the 28 July 2009 DDNS DoS attack vulnerability announcement is here. Some emails were sent with an incorrect URL reference. We apologize for the confusion.

OpenSSL security advisory CVE-2008-5077 may affect BIND users. The OpenSSL advisory says:

Several functions inside OpenSSL incorrectly checked the result after calling the EVP_VerifyFinal function, allowing a malformed signature to be treated as a good signature rather than as an error. This issue affected the signature checks on DSA and ECDSA keys used with SSL/TLS.

It is theoretically possible to spoof answers returned from zones whose DNSKEY algorithms are affected by that OpenSSL issue.

Impact:

What type of installations or types of servers are vulnerable.  Are there any specific configurations that are or aren't exposed.  Are there specific environments that are more likely to experience this type of problem.  Can internal-only servers be impacted - that sort of thing.  Imagine yourself reading this as the administrator of a server - what do you need to know to assess the impact on your specific environment?

Workarounds:

BIND 9.3, 9.4, 9.5 and 9.6:

Disable the affected algorithms in named.conf. This will cause answers from zones signed only with DSA (3) and/or NSEC3DSA (6) to be treated as insecure.

BIND 9.3, 9.4, 9.5:

disable-algorithms . { DSA; };

BIND 9.6:

disable-algorithms . { DSA; NSEC3DSA; };

Active exploits:

None known at this time.

Solution: 

Upgrade OpenSSL to at least OpenSSL 0.9.8j, then upgrade BIND to 9.3.6-P1, 9.4.3-P1, 9.5.1-P1, 9.6.0-P1, which use the updated OpenSSL interface correctly.

There are no fixes planned for BIND 9.1 or BIND 9.2, as those releases do not implement the current DNSSEC protocol.

Questions should be addressed to bind9-bugs@isc.org.

Also see CVE-2008-5077 for the corresponding OpenSSL issue

Acknowledgements: Google Security Team.

Document Revision History:

2009-01-05 Initial pre-release text
2009-01-07 Public release with corrected CVE
2009-01-23 Solution revised

Related Documents:

See our BIND Security Matrix for a complete listing of Security Vulnerabilities and versions affected.

If you'd like more information on our Forum or product support please visit www.isc.org/support.

Do you still have questions?  Questions regarding this advisory should go to security-officer@isc.org

Note: ISC patches only currently supported versions. When possible we indicate EOL versions affected.

ISC Security Vulnerability Disclosure Policy:  Details of our current security advisory policy and practice can be found here: https://www.isc.org/security-vulnerability-disclosure-policy

This Knowledge Base article https://kb.isc.org/article/AA-00925 is the complete and official security advisory document.

Legal Disclaimer:
Internet Systems Consortium (ISC) is providing this notice on an "AS IS" basis. No warranty or guarantee of any kind is expressed in this notice and none should be implied. ISC expressly excludes and disclaims any warranties regarding this notice or materials referred to in this notice, including, without limitation, any implied warranty of merchantability, fitness for a particular purpose, absence of hidden defects, or of non-infringement. Your use or reliance on this notice or materials referred to in this notice is at your own risk. ISC may change this notice at any time.  A stand-alone copy or paraphrase of the text of this document that omits the document URL is an uncontrolled copy. Uncontrolled copies may lack important information, be out of date, or contain factual errors.


© 2001-2017 Internet Systems Consortium

For assistance with problems and questions for which you have not been able to find an answer in our Knowledge Base, we recommend searching our community mailing list archives and/or posting your question there (you will need to register there first for your posts to be accepted). The bind-users and the dhcp-users lists particularly have a long-standing and active membership.

ISC relies on the financial support of the community to fund the development of its open source software products. If you would like to support future product evolution and maintenance as well having peace of mind knowing that our team of experts are poised to provide you with individual technical assistance whenever you call upon them, then please consider our Professional Subscription Support services - details can be found on our main website.

Feedback
  • There is no feedback for this article
Quick Jump Menu